
from flask import Blueprint, request, jsonify,session
from manager.serverCenter import server
from model.Model import User,Emails
import base64
import requests
from bs4 import BeautifulSoup
from manager.tools import sqlOrmToJson
import xmindparser
from copy import deepcopy
from manager.tools import par_path
import os

db=server.db
tool = Blueprint("tools", __name__, url_prefix='/tool')
jiraAddress="http://jira.galaxy-immi.com"

def getheader(id_):
    result=db.session.query(User.jira_account,User.jira_password).filter_by(id=id_).first()
    db.session.close()
    if not result.jira_account and not result.jira_password:
        return
    headers={
        "Authorization":"Basic "+base64.b64encode((result.jira_account+":"+result.jira_password).encode('utf-8')).decode(),
        "accept":"application/json,text/javascript,*/*;q=0.01"
    }
    return headers

    
@tool.route('/testport/sendport', methods=["POST"])
def sendport():
    import yagmail
    data=request.json
    user = 'wallen.ywh@galaxyoversea.com'
    password = 'Ywh940509'
    yag = yagmail.SMTP( user=user, password=password, host='smtp.exmail.qq.com',port=465)
    yag.send(to=data["to"],cc=data["cc"],subject=data.get("subject"),contents=data.get("contents"))
    return jsonify({"code": 200, "message": f"{data.get('subject')}邮件发送成功"}),200
    
@tool.route('/testport/getproject', methods=["GET"])
def getproject():
    headers=getheader(session.get("id"))
    if not headers:
        return jsonify({"code": 502, "message": "请完善jira信息"}),502
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/rapidviews/viewsData?query=&startAt=0&maxResults=200",headers=headers).json()
    if result.get("views"):
        return jsonify({"code": 200, "message": "请求成功", "data": result.get("views")}),200
    else:
        return jsonify({"code": 402, "message": "未找到相关项目，请确认jira信息是否正确"}),402
    
@tool.route('/testport/iteration/<getproject>', methods=["GET"])
def iteration(getproject):
    headers=getheader(session.get("id"))
    if not headers:
        return jsonify({"code": 502, "message": "请完善jira信息"}),502
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(getproject),headers=headers).json()
    res=[]
    for each in result["sprints"]:
        res.append({"key":each["id"],"name":each["name"]})
    if res:
        return jsonify({"code": 200, "message": "请求成功", "data": res}),200
    else:
        return jsonify({"code": 402, "message": "未找到相关项目，请确认jira信息是否正确"}),402
    
@tool.route('/testport/reportinfo', methods=["GET"])
def reportinfo():
    project=request.args.get("project")
    iteration=request.args.get("iteration")
    headers=getheader(session.get("id"))
    # id_=requests.request("get",jiraAddress+"/rest/agile/1.0/board?projectKeyOrId="+project,headers=headers).json().get("values")[0].get("id")
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(project),headers=headers).json()
    all_=result.get("issues")
    status={}
    for k,v in result["entityData"]["statuses"].items():
        status[k]=v["statusName"]
    priority={}
    for k,v in result["entityData"]["priorities"].items():
        priority[k]=v["priorityName"]
    type_={}
    for k,v in result["entityData"]["types"].items():
        type_[str(k)]=v["typeName"]
        
    spList=[]
    sprint=None
    for i in result["sprints"]:
       if i["id"]==int(iteration):
           spList=i["issuesIds"]
           sprint=i["name"]
           break
    #    x:type_[x["typeId"]]=="测试用例"
    iterationitems=list(filter(lambda x:x["id"] in spList,all_))
    peoples={'test':[],'qian':[],'hou':[],'chan':[]}
    story=list(filter(lambda x:type_[x["typeId"]]=="Story",iterationitems))
    bug=list(filter(lambda x:type_[x["typeId"]]=="BUG",iterationitems))
    testcase=list(filter(lambda x:type_[x["typeId"]]=="测试用例",all_))
    keylist=list(map(lambda x:x.get("key"),testcase))
    for i in story:
        i["case"]=[]
        i["childrenTask"]=[i.get("key")]
        chan=''
        for m in i["extraFields"]:
            if m.get("id")=="reporter":
                chan=m.get("html")
                break
        if chan and chan not in peoples["chan"]:
            peoples["chan"].append(chan)
        i["peoples"]=[chan]
        info=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/issue/details.json?rapidViewId="+str(project)+"&issueIdOrKey="+i["key"]+"&loadSubtasks=true",headers=headers).json()
        for j in info.get("tabs").get("defaultTabs"):
            if j.get("tabId")=="SUB_TASKS":
                for m in j.get("subtaskEntries"):
                    k=None
                    if m.get("assignee"):
                        k=m.get("assignee").get("displayName")
                        if k not in i["peoples"]:
                            i["peoples"].append(k)
                    if (k and ( k in peoples["test"] or k in peoples["qian"] or k in peoples["hou"])) or not k:
                        continue
                    elif "【前端】" in m.get("summary"):
                        peoples["qian"].append(k) 
                    elif "【后端】" in m.get("summary"):
                        peoples["hou"].append(k)
                    elif ("测试" in m.get("summary") or "用例" in m.get("summary")):    
                        peoples["test"].append(k) 
                    i["childrenTask"].append(m.get("key"))
            elif j.get("tabId")=="THIRD_PARTY_TAB":
                for each in j.get("sections"):
                    if each["label"]=="测试用例":
                        soup=BeautifulSoup(each["html"],"html.parser")
                        i["case"]=[i.next_element for i in soup.select('tr>td[align="left"]>span>a') if i.next_element in keylist]
    for i in bug:
        info=requests.request("get",jiraAddress+"/rest/api/latest/issue/"+i.get("key"),headers=headers).json()
        m=requests.request("get",jiraAddress+"/secure/AjaxIssueEditAction!default.jspa?decorator=none&issueId="+str(i.get("id")),headers=headers).json()
        count=0
        for j in m.get("fields"):
            if j.get("label")=="严重程度":
                i["Severity"]=info["fields"][j.get("id")] and info["fields"][j.get("id")].get("value") or ""
                count+=1
            if j.get("label")=="BUG修复者":
                i["ascription"]=info["fields"][j.get("id")] and info["fields"][j.get("id")].get("displayName") or i.get("assigneeName")
                count+=1
            if count>=2:
                break
    res={"project":result["projects"][0]["name"],"sprint":sprint,"people":peoples,"story":story,"bug":bug,"testcase":testcase,"statusMap":status,"priorityMap":priority,"typeMap":type_}
    return jsonify({"code": 200, "message": "请求成功", "data": res}),200 


@tool.route('/testport/addemailuser', methods=["POST"])
def addemailuser():
    data=request.json
    addinfo=Emails(name=data.get("name"),address=data.get("address"))
    db.session.add(addinfo)
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功"}),200

@tool.route('/testport/deleteemailuser/<id_>', methods=["DELETE"])
def deleteemailuser(id_):
    db.session.query(Emails).filter_by(id=id_).delete()
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功"}),200

@tool.route('/testport/emailuserlist', methods=["GET"])
def emailuserlist():
    data=db.session.query(Emails.id,Emails.name,Emails.address).all()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功","data": sqlOrmToJson(data)}),200

@tool.route('/testport/editemailuser', methods=["POST"])
def editemailuser():
    db.session.query(Emails).filter_by(id=request.json.get("id")).update({"name":request.json.get("name"),"address":request.json.get("address")})
    db.session.commit()
    db.session.close()
    return jsonify({"code": 200, "message": "请求成功"}),200

@tool.route('/testcase/uploadcase', methods=["POST"])
def uplooadcase():
    data_=request.json
    headers=getheader(session.get("id"))
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(data_.get("project")),headers=headers).json()
    projectId,projectkey=result["projects"][0]["id"],result["projects"][0]["key"]
    data={ "fields": {
        "project": {
            "key": projectkey
        },
        "summary": "测试占位",
        "description": "文辉的测试",
        "issuetype": {
            "name": "测试用例"
        },
    }
    }
    result=requests.request("post",jiraAddress+"/rest/api/2/issue/",json=data,headers=headers).json()
    globalcaseId=result["id"]
    print(par_path)
    print(data_)
    file_path=par_path+'/uploadfile/'+data_.get("file_name")
    content= xmindparser.xmind_to_dict(file_path)
    def a(suiteName,suiteId,info,new,type):
        for each in info:
            oldinfo,newtype=deepcopy(new),type
            if not ((each["title"])=="Map" or (each["title"])=="测试用例" or (each["title"])=="sheet" or (each["title"])=="思维导图" or (each["title"])=="逻辑图" or (each["title"])=="括号图"):
                if not suiteName:
                    suiteName = each.get("title")
                    params={"tcIssueId":globalcaseId,"projectId":projectId,"sourcePage":"TEST_SUITE_TEST_CASE_PAGE","decorator":"dialog","inline":True}
                    requests.request("post",jiraAddress+"/secure/CreateTestSuite.jspa?projectId="+str(projectId),data={"inline":True,"decorator":"dialog","testSuiteName":suiteName},headers=headers)
                    text=requests.request("get",jiraAddress+"/secure/ShowLinkTestSuiteInPanel.jspa",params=params,headers=headers).content
                    soup=BeautifulSoup(text,"html.parser")
                    suiteId=soup.find("strong",string=suiteName).parent.find("input").attrs.get("value") 
                if type=="name":
                    string=each.get("title")
                    if "tc：" in each.get("title") or "tc：" in each.get("title") or "tc:" in each.get("title"):
                        string,newtype=each.get("title").replace("tc：","").replace("tc：","").replace("tc:",""),"step"
                    oldinfo["name"]=oldinfo.get("name") and oldinfo.get("name")+"->"+string or string
                elif type=="step":
                    newtype,oldinfo["step"]="expect",each.get("title")
                else:
                    oldinfo["expect"]=each.get("title")
            if each.get("topic") or each.get("topics"):
                each.get("topic") and a(suiteName,suiteId,[each.get("topic")],oldinfo,newtype)
                each.get("topics") and a(suiteName,suiteId,each.get("topics"),oldinfo,newtype)
            else:
                testId=requests.request("post",jiraAddress+"/rest/api/2/issue/",json={ "fields": {
                    "project": {
                        "key": projectkey
                    },
                    "summary": oldinfo["name"],
                    "issuetype": {
                        "name": "测试用例"
                    },
                }
                },headers=headers).json()["id"]
                requests.request("post",jiraAddress+"/rest/synapse/1.0/testStep/addTestStep",json={"tcId":testId,"step":oldinfo.get("step"),"expectedResult":oldinfo.get("expect"),"sequenceNumber":None},headers=headers)
                requests.request("post",jiraAddress+"/rest/synapse/latest/testSuite/addTestCaseMemberToTestSuites",json={"testSuiteIds":[suiteId],"testCaseId":testId},headers=headers)
    a(None,None,content,{},"name")
    requests.request("delete",jiraAddress+"/rest/api/2/issue/"+globalcaseId,headers=headers)
    os.remove(file_path)
    return jsonify({"code": 200, "message": "用例创建成功"}),200

@tool.route('/testcase/relevancycase/<id_>', methods=["POST"])
def relevancycase(id_):
    headers=getheader(session.get("id"))
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_),headers=headers).json()
    projectkey=result["projects"][0]["key"]
    result=requests.request("get",jiraAddress+"/rest/greenhopper/1.0/xboard/plan/backlog/data.json?rapidViewId="+str(id_)+"&selectedProjectKey="+projectkey,headers=headers).json()
    all,type_,storyids=result.get("issues"),{},{}
    for k,v in result["entityData"]["types"].items():
        type_[str(k)]=v["typeName"]
    [storyids.update({i.get("key"):[]}) for i in list(filter(lambda x:type_[x["typeId"]]=="Story",all))]
    for item in list(filter(lambda x:type_[x["typeId"]]=="测试用例",all)):
        for each in storyids.keys():
            each in item.get("summary") and storyids[each].append(item.get("key"))
    for k,v in storyids.items():
        requests.request("post",jiraAddress+"/rest/synapse/latest/requirementTestCase/addTestCase",headers=headers,json={"currentReqkey":k,"testCaseKeys":v,"history":"yes"})
    return jsonify({"code": 200, "message": "用例关联执行结束"}),200
    
